-- sort.lua
-- Written By MrJackdaw, tweak by Habna for HugeBag


function Sort()
	if IsSorting or IsMixing or IsMerging or IsSearching then
		write("Can't sort when sort, mix, merge or search function are active!");
		return
	end
	
	local VirtPack = {};

	for i = 1, backpackSize do
		VirtPack[i] = {};
		VirtPack[i].id = i;

		local item = Backpack:GetItem(i);

		if item ~= nil then
			VirtPack[i].Name = item:GetName();

			local Quality = item:GetQuality();
			--if Quality == nil then Quality = 0; end
			--VirtPack[i].Quanlity = Quanlity;

			local Quantity = item:GetQuantity();
			--if Quantity == nil then Quantity = 1; end
			VirtPack[i].Quantity = Quantity;
			
			local Category = item:GetCategory();
			--if Category == nil then Category = 172; end
			--VirtPack[i].Category = Category;
			
			local Type = ItemCategory[Category];
			if Type == nil then Type = "SpecialTrophy"; end
			--VirtPack[i].Type = Type;

			local CatWeight = value[Type];

			VirtPack[i].Weight = CatWeight * 10 + Quality;
		else
			VirtPack[i].Name = "zEmpty";
			VirtPack[i].Quantity = 0;
			VirtPack[i].Weight = 99999;
		end
	end

	--Sort VirtPack. If the weight of two items is the same compare the Names, after removing some characters.
	--This way "2 Morale Potions" will get sorted with "Morale Potions"
	table.sort(VirtPack, function (a,b)	
		if a.Weight == b.Weight then
			if a.Name == b.Name then
				return (a.Quantity < b.Quantity)
			else  
				return strip(a.Name) < strip(b.Name)
			end
		else  
			return (a.Weight < b.Weight) 
		end
		end)
	

	IsSorting = true;
	SortButton:SetVisible( false );
	SearchButton:SetVisible( false );
	MergeButton:SetVisible( false );

	local Slot = 1;
	write( "HugeBag: Sorting started" );
	FirstStart = Turbine.Engine.GetGameTime();
	Timer = Turbine.UI.Control();
	Timer:SetWantsUpdates( true );

	Timer.Update = function( sender, args )
		if Slot > backpackSize then
			Timer:SetWantsUpdates( false );

			if ShowButton then
				SortButton:SetVisible( true );
				SearchButton:SetVisible( true );
				MergeButton:SetVisible( true );
			end
	
			IsSorting = false;
			write( "HugeBag: Sorting finished" );
			local Time = Turbine.Engine.GetGameTime();
			write("<rgb=#888888>Sorting finished after ".. string.format( "%.2f", Time - FirstStart ) .." seconds.")
		end
		
		if Slot > backpackSize then return end

		--Get the quantity & name of the target item
		targetName = VirtPack[Slot].Name;
		target = VirtPack[Slot].Quantity .. " " .. targetName;
		
		--Search the target item in bag.
		for i = Slot, backpackSize do
			item = Backpack:GetItem( i );

			if item ~= nil then
				itemName = item:GetName();
				itemQuantity = item:GetQuantity();
			else
				itemName = "zEmpty";
				itemQuantity = 0;
			end
			source = itemQuantity .. " " .. itemName;
			--write(source .. " / " .. target);
			if source == target then
				if i == Slot then Slot = Slot + 1 return end
				--write(source .. " found at " .. i .. " / Slot " .. Slot .. ": " .. target);
				-- Check if item in destination slot is not the same item that will go there, cause if true them a merge will
				-- be perform and sort will not end properly, making button not visible and can't perform sort again.
				local ditem = Backpack:GetItem( Slot );
				if ditem ~= nil then
					ditemName = ditem:GetName();
					ditemMaxStackSize = ditem:GetMaxStackSize(); -- if max = 1 then it's not stackable
					--write("Slot: " .. i .. " item max stack size is : " .. ditemMaxStackSize);
					--write(ditemName .. " / " .. itemName);
					if ditemName == itemName then
						-- check if destination item is stackable
						--write(ditemMaxStackSize);
						if ditemMaxStackSize > 1 then
							--write("Moving item in " .. Slot .. " to a free slot");
							-- Yes it's stackable and same name. Move it to an empty slot
							local found = false;
							for FreeSlot = Slot + 1, backpackSize do
								local freeLoc = Backpack:GetItem( FreeSlot );
								if freeLoc == nil then -- Free space found
									found = true;
									--write("Free slot found at " .. FreeSlot);
									Backpack:PerformItemDrop(ditem, FreeSlot, false);
									break
								end
							end
							--write("Found: " .. tostring(found));
							-- No free slot was found in bag, move to next slot that is not same item name
							if not found then
								--write("No free slot available. Moving to next slot");
								for NextSlot = Slot + 1, backpackSize do
									--write(tostring(NextSlot));
									local nextItem = Backpack:GetItem( NextSlot );
									if nextItem ~= nil then
										nitemName = nextItem:GetName();
										if nitemName ~= ditemName then
											Backpack:PerformItemDrop(ditem, NextSlot, false);
											break
										end
									end
								end
							end
						end
					end
				end


				if Lasti == i then
					Lasti = nil;
					i = i - 1;
				else
					if item ~= nil then
						--write("Performing item drop to slot " .. i);
						Backpack:PerformItemDrop(item, Slot, false);
						Lasti = i; --Last item move (slot number)
						Slot = Slot + 1;
						return
					end
				end
			end
		end
	end
end

function strip(str)
	--Strip numbers first 7 characters to make the sort more logical
	local left=string.sub(str, 1, 7)
	local right=string.sub(str, 8)
	left=string.gsub(left,"[^%a]","")
	str= left .. right

	--Strip all spaces now!
	str=string.gsub(str,"[%s]","")
	return str
end